--AH:ScriptId=6d915670-8d3e-479a-9e5f-a06653f901bd;3003
INSERT [Pipelines] ([Pipeline_Name], [Pipeline_Configuration], [Active_Indicator], [Application_Id], [ModifiedOn_Date], [ModifiedBy_User_Name], [MigratedFrom_Workflow_Id], [Pipeline_Color])
SELECT
    WE.[Workflow_Name],    
    CAST((SELECT
        'BuildMaster' AS [@Assembly],
        (SELECT
            W.[Workflow_Name] AS [@Name],
            '#' + W.[Color_Code] AS [@Color],
            '' AS [@Description],
            CASE WHEN W.[AllowOutOfSequencePromotions_Indicator] = 'N' THEN 'True' ELSE 'False' END AS [@EnforceStageSequence],
            (SELECT
                -- Build step with deployment plan
                (SELECT
                    'BuildMaster' AS [@Assembly],
                    (SELECT
                        'Build' AS [@Name],
                        CASE WHEN W2.[Build_AutoPromote_Indicator] = 'Y' THEN 'True' ELSE 'False' END AS [@AutoPromote],
                        (SELECT
                            (SELECT
                                'BuildMaster' AS [@Assembly],
                                (SELECT
                                    'LEGACY::' + CAST(W2.[Build_DeploymentPlan_Id] AS VARCHAR(MAX)) AS [@PlanName],
                                    'Build' AS [@EnvironmentName]
                                FOR XML PATH ('Properties'), TYPE)
                            FOR XML PATH ('Inedo.BuildMaster.Pipelines.PipelineStageTarget'), TYPE)
                        FOR XML PATH ('Targets'), TYPE)
                    FOR XML PATH ('Properties'), TYPE),

                    (SELECT
                        CAST(EL.[EventListener_Configuration] AS XML)
                            FROM [EventListeners] EL
                            WHERE EL.[BuildStep_Workflow_Id] = W2.[Workflow_Id]
                    FOR XML PATH ('PostDeploymentEventListeners'), TYPE)

                   FROM [Workflows] W2
                  WHERE W2.[Workflow_Id] = W.[Workflow_Id]
                    AND [Build_DeploymentPlan_Id] IS NOT NULL
                FOR XML PATH ('Inedo.BuildMaster.Pipelines.PipelineStage'), TYPE),

                -- Build step with importer
                (SELECT
                    'BuildMaster' AS [@Assembly],
                    (SELECT
                        'Build' AS [@Name],
                        (SELECT
                            (SELECT
                                'BuildMaster' AS [@Assembly],
                                (SELECT
                                    W2.[BuildImporterTemplate_Configuration] AS [BuildImporterTemplate]
                                FOR XML PATH ('Properties'), TYPE)
                            FOR XML PATH ('Inedo.BuildMaster.Pipelines.PipelineStageTarget'), TYPE)
                        FOR XML PATH ('Targets'), TYPE)
                    FOR XML PATH ('Properties'), TYPE),

                    (SELECT
                        CAST(EL.[EventListener_Configuration] AS XML)
                            FROM [EventListeners] EL
                            WHERE EL.[BuildStep_Workflow_Id] = W2.[Workflow_Id]
                    FOR XML PATH ('PostDeploymentEventListeners'), TYPE)

                   FROM [Workflows] W2
                  WHERE W2.[Workflow_Id] = W.[Workflow_Id]
                    AND W.[BuildImporterTemplate_Configuration] IS NOT NULL
                FOR XML PATH ('Inedo.BuildMaster.Pipelines.PipelineStage'), TYPE),

                (SELECT 
                    'BuildMaster' AS [@Assembly],
                    (SELECT
                        E.[Environment_Name] AS [@Name],
                        CASE WHEN WS.[AutoPromote_Indicator] = 'Y' THEN 'True' ELSE 'False' END AS [@AutoPromote],
                    
                        (SELECT
                            (SELECT
                                'BuildMaster' AS [@Assembly],
                                (SELECT
                                    'LEGACY::' + CAST(WS.[DeploymentPlan_Id] AS VARCHAR(MAX)) AS [@PlanName],
                                    E.[Environment_Name] AS [@EnvironmentName]
                                FOR XML PATH ('Properties'), TYPE)
                            FOR XML PATH ('Inedo.BuildMaster.Pipelines.PipelineStageTarget'), TYPE)
                        FOR XML PATH ('Targets'), TYPE),

                        (SELECT
                            (SELECT
                                'BuildMaster' AS [@Assembly],
                                (SELECT
                                
                                    (SELECT
                                        (SELECT
                                            'BuildMaster' AS [@Assembly],
                                            (SELECT
                                                [Principal_Name] AS [@Name],
                                                [Requirement_Description] AS [@Description]
                                                FOR XML PATH ('Properties'), TYPE)
                                              FROM [BuildPromotionRequirements] BRP
                                             WHERE BRP.[RequiredInGroup_Count] IS NULL -- = 'U'
                                               AND BRP.[Requirement_Configuration] IS NULL
                                               AND WS.[Environment_Id] = BRP.[Environment_Id]
                                               AND W.[Workflow_Id] = BRP.[Workflow_Id]
                                            FOR XML PATH ('Inedo.BuildMaster.Pipelines.UserApproval'), TYPE)
                                            
                                    FOR XML PATH ('UserApprovals'), TYPE),

                                    (SELECT
                                        (SELECT
                                            'BuildMaster' AS [@Assembly],
                                            (SELECT
                                                [Principal_Name] AS [@Name],
                                                [Requirement_Description] AS [@Description],
                                                [RequiredInGroup_Count] AS [@Count]
                                                FOR XML PATH ('Properties'), TYPE)
                                              FROM [BuildPromotionRequirements] BRP
                                             WHERE BRP.[RequiredInGroup_Count] IS NOT NULL -- = 'G'
                                               AND WS.[Environment_Id] = BRP.[Environment_Id]
                                               AND W.[Workflow_Id] = BRP.[Workflow_Id]
                                            FOR XML PATH ('Inedo.BuildMaster.Pipelines.GroupApproval'), TYPE)
                                            
                                    FOR XML PATH ('GroupApprovals'), TYPE),

                                    (SELECT
                                            -- CAST is used here to prevent surrounding Requirement_Configuration element
                                            CAST(BRP.[Requirement_Configuration] AS XML)
                                           FROM [BuildPromotionRequirements] BRP
                                          WHERE BRP.[Requirement_Configuration] IS NOT NULL -- = 'A'
                                            AND WS.[Environment_Id] = BRP.[Environment_Id]
                                            AND W.[Workflow_Id] = BRP.[Workflow_Id]
                                    FOR XML PATH ('AutomaticApprovals'), TYPE)

                                FOR XML PATH ('Properties'), TYPE)
                            FOR XML PATH ('Inedo.BuildMaster.Pipelines.PipelineStageGate'), TYPE)
                        FOR XML PATH ('Gate'), TYPE),

                        (SELECT
                            CAST(EL.[EventListener_Configuration] AS XML)
                                FROM [EventListeners] EL
                                WHERE EL.[WorkflowStep_Workflow_Id] = W.[Workflow_Id]
                                  AND EL.[WorkflowStep_Environment_Id] = WS.[Environment_Id]
                        FOR XML PATH ('PostDeploymentEventListeners'), TYPE)

                    FOR XML PATH ('Properties'), TYPE)     
                    FROM [WorkflowSteps] WS
                    INNER JOIN [Environments] E
                            ON WS.[Environment_Id] = E.[Environment_Id]
                    LEFT JOIN [DeploymentPlans] DP
	                        ON DP.[DeploymentPlan_Id] = WS.[DeploymentPlan_Id]
                    WHERE WS.[Workflow_Id] = W.[Workflow_Id]
                    ORDER BY WS.[Step_Sequence]
                FOR XML PATH ('Inedo.BuildMaster.Pipelines.PipelineStage'), TYPE)        
            FOR XML PATH ('Stages'), TYPE),
            (SELECT 
                (SELECT
                    'BuildMaster' AS [@Assembly],
                    (SELECT
                        CASE WHEN W.[AutoIncrementRelease_Indicator] = 'Y' THEN 'True' ELSE 'False' END AS [@CreateRelease],
                        CASE WHEN W.[AutoCancelReleases_Indicator] = 'Y' THEN 'True' ELSE 'False' END AS [@CancelReleases],
                        CASE WHEN W.[AutoDeployRelease_Indicator] = 'Y' THEN 'True' ELSE 'False' END AS [@DeployRelease]
                    FOR XML PATH ('Properties'), TYPE)
                FOR XML PATH ('Inedo.BuildMaster.Pipelines.PipelinePostDeploymentOptions'), TYPE)
            FOR XML PATH ('PostDeploymentOptions'), TYPE)
        FOR XML PATH ('Properties'), TYPE)
    FROM [Workflows] W
    WHERE W.[Workflow_Id] = WE.[Workflow_Id]
    FOR XML PATH ('Inedo.BuildMaster.Pipelines.Pipeline')) AS XML),
    
    WE.[Active_Indicator],
    A.[Application_Id], -- Single_Application_Id
    WE.[ModifiedOn_Date],
    WE.[ModifiedBy_User_Name],
    WE.[Workflow_Id],
    WE.[Color_Code]
    
  FROM [Workflows] WE
  LEFT  JOIN [ApplicationWorkflows] AW
		           ON AW.[Workflow_Id] = WE.[Workflow_Id]
	              AND 1 = (SELECT COUNT(*) FROM [ApplicationWorkflows] _AW
	                        WHERE _AW.[Workflow_Id] = WE.[Workflow_Id])

           LEFT  JOIN [Applications] A
	               ON A.[Application_Id] = AW.[Application_Id]