--AH:ScriptId=a0b4a287-0b8c-452b-b992-5cfd097f87fe;3024

DECLARE @Map TABLE ([From_Name] NVARCHAR(50) NOT NULL, [To_Name] VARCHAR(50) NULL, [From_Id] INT NULL, [To_Id] INT NULL)
INSERT @Map ([From_Name], [To_Name])
		  SELECT 'Administrator', 'Administer'
UNION ALL SELECT 'BuildMaster', 'Administer'
UNION ALL SELECT 'Developer', 'Deploy to Environment'
UNION ALL SELECT 'View Only', 'View Application'

UPDATE @Map
   SET [From_Id] = R_FROM.[Role_Id],
       [To_Id] = R_TO.[Role_Id]
  FROM @Map
    INNER JOIN [Roles] R_FROM ON R_FROM.[Role_Name] = [From_Name]
    INNER JOIN [Roles] R_TO ON R_TO.[Role_Name] = [To_Name]


DECLARE @RoleTasks TABLE ([Role_Id] INT, [Task_Id] INT)

INSERT @RoleTasks ([Role_Id], [Task_Id])
  SELECT [Role_Id], [Task_Id]
    FROM [RoleTasks]

UPDATE @RoleTasks
   SET [Role_Id] = M.[To_Id]
  FROM @RoleTasks RT
  INNER JOIN @Map M ON RT.[Role_Id] = M.[From_Id]
  
DELETE [RoleTasks]

INSERT [RoleTasks] ([Role_Id], [Task_Id])
  SELECT DISTINCT [Role_Id], [Task_Id] FROM @RoleTasks

UPDATE [Privileges]
   SET [Role_Id] = M.[To_Id]
  FROM [Privileges] P
 INNER JOIN @Map M ON P.[Role_Id] = M.[From_Id]

DELETE [Roles] WHERE [Role_Name] IN ('Administrator', 'BuildMaster', 'Developer', 'View Only')

IF NOT EXISTS(
    SELECT * FROM [Privileges] P
     INNER JOIN [Roles] R ON R.[Role_Id] = P.[Role_Id]
     WHERE R.[Role_Name] = 'QA Analyst')
BEGIN
    
    DELETE [RoleTasks]
      FROM [RoleTasks] RT
     INNER JOIN [Roles] R ON R.[Role_Id] = RT.[Role_Id]
     WHERE R.[Role_Name] = 'QA Analyst'

     DELETE [Roles]
      WHERE [Role_Name] = 'QA Analyst'

END