EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Environments_GetEnvironments',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Environments_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets all environments.'
GO

IF OBJECT_ID('[Environments_GetEnvironments]') IS NOT NULL DROP PROCEDURE [Environments_GetEnvironments]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Environments_GetEnvironments]
(
    @IncludeInactive_Indicator YNINDICATOR = NULL
)
AS
BEGIN

	SELECT E.*
	  FROM [Environments_Extended] E
	 WHERE @IncludeInactive_Indicator = 'Y' OR E.[Active_Indicator] = 'Y'
	 ORDER BY [Display_Sequence]

END
GO

GRANT EXECUTE ON [Environments_GetEnvironments] TO [BuildMasterUser_Role]