EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Executions_PurgeExecution',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Purges an execution and all associated logs.'
GO

IF OBJECT_ID('[Executions_PurgeExecution]') IS NOT NULL DROP PROCEDURE Executions_PurgeExecution
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Executions_PurgeExecution]
(
	@Execution_Id INT
) AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	DELETE [BuildTestResults]
	 WHERE [Execution_Id] = @Execution_Id

	DELETE [BuildOutputs]
	 WHERE [Execution_Id] = @Execution_Id

	DELETE [ManualActionsInProgress]
	 WHERE [Execution_Id] = @Execution_Id

	DELETE [DatabaseChangeScriptExecutions]
	 WHERE [Execution_Id] = @Execution_Id

	DELETE [ScopedExecutionLogEntries]
	 WHERE [Execution_Id] = @Execution_Id

	DELETE [ScopedExecutionLogs]
	 WHERE [Execution_Id] = @Execution_Id

	DELETE [PipelineStageTargetExecutions]
	 WHERE [Execution_Id] = @Execution_Id

	DELETE [Executions]
	 WHERE [Execution_Id] = @Execution_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Executions_PurgeExecution] TO [BuildMasterUser_Role]
