EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Promotions_ImportPromotion',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ 'Promotion_Id',
    /* Description_Text        */ 'Imports promotion information.'
GO

IF OBJECT_ID('[Promotions_ImportPromotion]') IS NOT NULL DROP PROCEDURE [Promotions_ImportPromotion]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Promotions_ImportPromotion]
(
	@Build_Id INT,
	@Promoted_Date DATETIME,
	@PromotedBy_Name USERNAME,
	@Comments_Text VARCHAR(255),
	@PromotionStatus_Name VARCHAR(20),
	@StatusOverriddenBy_User_Name USERNAME,
	@StatusOverriddenReason_Text VARCHAR(100),
	@StatusOverridden_Date DATETIME,
	@Forced_Indicator YNINDICATOR,
	@PipelineStage_Name VARCHAR(50),
	@Promotion_Id INT = NULL OUT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	INSERT INTO [BuildPromotions]
	(
		[Build_Id],
		[Promoted_Date],
		[PromotedBy_Name],
		[Comments_Text],
		[PromotionStatus_Name],
		[StatusOverriddenBy_User_Name],
		[StatusOverriddenReason_Text],
		[StatusOverridden_Date],
		[Forced_Indicator],
		[PipelineStage_Name]
	)
	VALUES
	(
		@Build_Id,
		@Promoted_Date,
		@PromotedBy_Name,
		@Comments_Text,
		@PromotionStatus_Name,
		@StatusOverriddenBy_User_Name,
		@StatusOverriddenReason_Text,
		@StatusOverridden_Date,
		@Forced_Indicator,
		@PipelineStage_Name
	)

	SET @Promotion_Id = SCOPE_IDENTITY()

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Promotions_ImportPromotion] TO [BuildMasterUser_Role]
